aboutsummaryrefslogtreecommitdiff
path: root/ci/common
diff options
context:
space:
mode:
authorNikolai Aleksandrovich Pavlov <kp-pav@yandex.ru>2017-03-31 15:32:58 +0300
committerJustin M. Keyes <justinkz@gmail.com>2017-03-31 14:32:58 +0200
commita1c928e70cd995426449ac6ec6df3b5a492580e5 (patch)
tree6996b02ac2ecbd3e8894f38b74ecc762d69f3cbb /ci/common
parent77539eef9baa0d070a1d07360dda2177c2ae41a7 (diff)
downloadrneovim-a1c928e70cd995426449ac6ec6df3b5a492580e5.tar.gz
rneovim-a1c928e70cd995426449ac6ec6df3b5a492580e5.tar.bz2
rneovim-a1c928e70cd995426449ac6ec6df3b5a492580e5.zip
ci: Do not hide ci directory (#6410)
Diffstat (limited to 'ci/common')
-rw-r--r--ci/common/build.sh81
-rw-r--r--ci/common/test.sh148
2 files changed, 229 insertions, 0 deletions
diff --git a/ci/common/build.sh b/ci/common/build.sh
new file mode 100644
index 0000000000..44087513ee
--- /dev/null
+++ b/ci/common/build.sh
@@ -0,0 +1,81 @@
+build_deps() {
+ if [[ "${BUILD_32BIT}" == ON ]]; then
+ DEPS_CMAKE_FLAGS="${DEPS_CMAKE_FLAGS} ${CMAKE_FLAGS_32BIT}"
+ fi
+ if [[ "${FUNCTIONALTEST}" == "functionaltest-lua" ]]; then
+ DEPS_CMAKE_FLAGS="${DEPS_CMAKE_FLAGS} -DUSE_BUNDLED_LUA=ON"
+ fi
+
+ rm -rf "${DEPS_BUILD_DIR}"
+
+ # If there is a valid cache and we're not forced to recompile,
+ # use cached third-party dependencies.
+ if [[ -f "${CACHE_MARKER}" ]] && [[ "${BUILD_NVIM_DEPS}" != true ]]; then
+ if [[ "${TRAVIS_OS_NAME}" == osx ]]; then
+ local statcmd="stat -f '%Sm'"
+ else
+ local statcmd="stat -c '%y'"
+ fi
+ echo "Using third-party dependencies from Travis's cache (last updated: $(${statcmd} "${CACHE_MARKER}"))."
+
+ mkdir -p "$(dirname "${DEPS_BUILD_DIR}")"
+ mv "${HOME}/.cache/nvim-deps" "${DEPS_BUILD_DIR}"
+ else
+ mkdir -p "${DEPS_BUILD_DIR}"
+ fi
+
+ # Even if we're using cached dependencies, run CMake and make to
+ # update CMake configuration and update to newer deps versions.
+ cd "${DEPS_BUILD_DIR}"
+ echo "Configuring with '${DEPS_CMAKE_FLAGS}'."
+ CC= cmake ${DEPS_CMAKE_FLAGS} "${TRAVIS_BUILD_DIR}/third-party/"
+
+ if ! ${MAKE_CMD}; then
+ exit 1
+ fi
+
+ cd "${TRAVIS_BUILD_DIR}"
+}
+
+prepare_build() {
+ if [[ -n "${CLANG_SANITIZER}" ]]; then
+ CMAKE_FLAGS="${CMAKE_FLAGS} -DCLANG_${CLANG_SANITIZER}=ON"
+ fi
+ if [[ "${BUILD_32BIT}" == ON ]]; then
+ CMAKE_FLAGS="${CMAKE_FLAGS} ${CMAKE_FLAGS_32BIT}"
+ fi
+
+ mkdir -p "${BUILD_DIR}"
+ cd "${BUILD_DIR}"
+ echo "Configuring with '${CMAKE_FLAGS} $@'."
+ cmake ${CMAKE_FLAGS} "$@" "${TRAVIS_BUILD_DIR}"
+}
+
+build_nvim() {
+ echo "Building nvim."
+ if ! ${MAKE_CMD} nvim; then
+ exit 1
+ fi
+
+ if [ "$CLANG_SANITIZER" != "TSAN" ]; then
+ echo "Building libnvim."
+ if ! ${MAKE_CMD} libnvim; then
+ exit 1
+ fi
+
+ echo "Building nvim-test."
+ if ! ${MAKE_CMD} nvim-test; then
+ exit 1
+ fi
+ fi
+
+ # Invoke nvim to trigger *San early.
+ if ! (bin/nvim --version && bin/nvim -u NONE -e -c ':qall'); then
+ asan_check "${LOG_DIR}"
+ exit 1
+ fi
+ asan_check "${LOG_DIR}"
+
+
+ cd "${TRAVIS_BUILD_DIR}"
+}
diff --git a/ci/common/test.sh b/ci/common/test.sh
new file mode 100644
index 0000000000..b28e46a4df
--- /dev/null
+++ b/ci/common/test.sh
@@ -0,0 +1,148 @@
+print_core() {
+ local app="$1"
+ local core="$2"
+ if test "$app" = quiet ; then
+ echo "Found core $core"
+ return 0
+ fi
+ echo "======= Core file $core ======="
+ if [[ "${TRAVIS_OS_NAME}" == osx ]]; then
+ lldb -Q -o "bt all" -f "${app}" -c "${core}"
+ else
+ gdb -n -batch -ex 'thread apply all bt full' "${app}" -c "${core}"
+ fi
+}
+
+check_core_dumps() {
+ local del=
+ if test "$1" = "--delete" ; then
+ del=1
+ shift
+ fi
+ local app="${1:-${BUILD_DIR}/bin/nvim}"
+ if [[ "${TRAVIS_OS_NAME}" == osx ]]; then
+ local cores="$(find /cores/ -type f -print)"
+ else
+ local cores="$(find ./ -type f -name 'core.*' -print)"
+ fi
+
+ if [ -z "${cores}" ]; then
+ return
+ fi
+ local core
+ for core in $cores; do
+ if test "$del" = "1" ; then
+ print_core "$app" "$core" >&2
+ rm "$core"
+ else
+ print_core "$app" "$core"
+ fi
+ done
+ if test "$app" = quiet ; then
+ return 0
+ fi
+ exit 1
+}
+
+check_logs() {
+ # Iterate through each log to remove an useless warning.
+ for log in $(find "${1}" -type f -name "${2}"); do
+ sed -i "${log}" \
+ -e '/Warning: noted but unhandled ioctl/d' \
+ -e '/could cause spurious value errors to appear/d' \
+ -e '/See README_MISSING_SYSCALL_OR_IOCTL for guidance/d'
+ done
+
+ # Now do it again, but only consider files with size > 0.
+ local err=""
+ for log in $(find "${1}" -type f -name "${2}" -size +0); do
+ cat "${log}"
+ err=1
+ done
+ if [[ -n "${err}" ]]; then
+ echo "Runtime errors detected."
+ exit 1
+ fi
+}
+
+valgrind_check() {
+ check_logs "${1}" "valgrind-*"
+}
+
+asan_check() {
+ check_logs "${1}" "*san.*"
+}
+
+run_unittests() {
+ ulimit -c unlimited
+ if ! ${MAKE_CMD} -C "${BUILD_DIR}" unittest ; then
+ check_core_dumps "$(which luajit)"
+ exit 1
+ fi
+ check_core_dumps "$(which luajit)"
+}
+
+run_functionaltests() {
+ ulimit -c unlimited
+ if ! ${MAKE_CMD} -C "${BUILD_DIR}" ${FUNCTIONALTEST}; then
+ asan_check "${LOG_DIR}"
+ valgrind_check "${LOG_DIR}"
+ check_core_dumps
+ exit 1
+ fi
+ asan_check "${LOG_DIR}"
+ valgrind_check "${LOG_DIR}"
+ check_core_dumps
+}
+
+run_oldtests() {
+ ulimit -c unlimited
+ if ! make -C "${TRAVIS_BUILD_DIR}/src/nvim/testdir"; then
+ reset
+ asan_check "${LOG_DIR}"
+ valgrind_check "${LOG_DIR}"
+ check_core_dumps
+ exit 1
+ fi
+ asan_check "${LOG_DIR}"
+ valgrind_check "${LOG_DIR}"
+ check_core_dumps
+}
+
+install_nvim() {
+ ${MAKE_CMD} -C "${BUILD_DIR}" install
+
+ "${INSTALL_PREFIX}/bin/nvim" --version
+ "${INSTALL_PREFIX}/bin/nvim" -u NONE -e -c ':help' -c ':qall' || {
+ echo "Running ':help' in the installed nvim failed."
+ echo "Maybe the helptags have not been generated properly."
+ exit 1
+ }
+
+ local genvimsynf=syntax/vim/generated.vim
+ # Check that all runtime files were installed
+ for file in doc/tags $genvimsynf $(
+ cd runtime ; git ls-files | grep -e '.vim$' -e '.ps$' -e '.dict$' -e '.py$' -e '.tutor$'
+ ) ; do
+ if ! test -e "${INSTALL_PREFIX}/share/nvim/runtime/$file" ; then
+ echo "It appears that $file is not installed."
+ exit 1
+ fi
+ done
+
+ # Check that generated syntax file has function names, #5060.
+ local gpat='syn keyword vimFuncName .*eval'
+ if ! grep -q "$gpat" "${INSTALL_PREFIX}/share/nvim/runtime/$genvimsynf"; then
+ echo "It appears that $genvimsynf does not contain $gpat."
+ exit 1
+ fi
+
+ for file in $(
+ cd runtime ; git ls-files | grep -e '.awk$' -e '.sh$' -e '.bat$'
+ ) ; do
+ if ! test -x "${INSTALL_PREFIX}/share/nvim/runtime/$file" ; then
+ echo "It appears that $file is not installed or is not executable."
+ exit 1
+ fi
+ done
+}